**************************************************************************
*
* Degas PC1 depack routine v2.0 by Rob Cooper
* For Devpac 3
*
* Trashes registers D0-D7/A0-A2
*
* Fits in the instrucion cache for maximum speed :-]
* Tabsize 10
*
* Call method:
*
*	pea	data
*	pea	dest
*	bsr	DepackPC1
*	addq	#8,sp
*
* The file PC1_DPCK.BIN can be used in high level langauges. For example, in 
* GFA Basic you would use:
* 
* INLINE pc1_depack%,130		!load file into here
* ~C:pc1_depack%(L:dest_addr%,L:source_addr%)
* 

	opt	D-
	OUTPUT	.BIN

test	equ	0
	IFNE	test
	pea	SavePal(pc)
	move	#38,-(sp)
	trap	#14	;save pal
	addq	#6,sp
	move	#4,-(sp)
	trap	#14
	addq	#2,sp
	move	d0,OldRez
	clr	-(sp)
	pea	-1.w
	pea	-1.w
	move	#5,-(sp)
	trap	#14
	add	#12,sp
	pea	pic+2(pc)
	move	#6,-(sp)
	trap	#14	;set pal
	addq	#6,sp
	move	#2,-(sp)
	trap	#14	;Physbase
	addq	#2,sp
	pea	pic+34(pc)
	move.l	d0,-(sp)
	bsr	DepackPC1
	addq	#8,sp
	move	#7,-(sp)
	trap	#1	;waitkey
	addq	#2,sp
	move	OldRez(pc),-(sp)
	pea	-1.w
	pea	-1.w
	move	#5,-(sp)
	trap	#14
	add	#12,sp
	pea	OldPal(pc)
	move	#6,-(sp)
	trap	#14	;restore pal
	addq	#6,sp
	clr	-(sp)
	trap	#1
SavePal	movem.l	$ffff8240.w,d0-d7
	movem.l	d0-d7,OldPal
	rts
	DATA
pic	incbin	"\proj\testdata\test_1.pc1"
OldPal	ds.w 16
OldRez	ds.w 1
	TEXT
	opt	o+,ow+,p+,s-
	ENDC


DepackPC1:
._152	equr	d0
.planecnt	equr	d1
.plane	equr	d2
._7	equr	d3
.temp	equr	d4
._256	equr	d5
.control	equr	d6
._1	equr	d7
.source	equr	a0
.logic	equr	a1
.final	equr	a2
._158	equr	a3
.f_planecnt	equ 40-1
.f_plane		equ 4-1

	move.l	4(sp),.logic
	move.l	8(sp),.source
	pea	(a3)			;save
	moveq	#.f_planecnt,.planecnt
	moveq	#.f_plane,.plane
	move	#256,._256
	movea.w	#158,._158
	move.l	#152,._152
	moveq	#1,._1
	moveq	#7,._7

	lea	160*200(.logic),.final
LineLoop:	clr	.control
	move.b	(.source)+,.control
	bmi.s	.same

*-> Different bytes
.diff	move.b	(.source)+,(.logic)
	subq	#1,.planecnt
	add.l	._1,.logic
	exg	._1,._7
	dbf	.control,.diff

.next:	tst	.planecnt
	bge.s	LineLoop
	moveq	#.f_planecnt,.planecnt
	sub.l	._158,.logic		;next plane on same line
	dbf	.plane,LineLoop

.new_line	moveq	#.f_plane,.plane
	adda.l	._152,.logic
	cmpa.l	.final,.logic
	blt.s	LineLoop
.exit	move.l	(sp)+,a3
	rts

*-> Same byte (256-control) times
.same:	neg	.control
	add	._256,.control
	move.b	(.source)+,.temp
.s1	move.b	.temp,(.logic)
	subq	#1,.planecnt
	add.l	._1,.logic
	exg	._1,._7
	dbf	.control,.s1
	bra.s	.next
